<style>
    table 
    {
        width: 100%;
        border-collapse: collapse;
    }

    td, th 
    {
        border: medium solid #000000;
        width: 50%;
        padding : 5px;
    }

    textarea
    {
        width: 100%;
        background-color : #effaff;
    }

    .titre_tableau
    {
        background-color : #d7e4e9;
    }
    
    .bouton_sav
    {
        margin-left : 1%;
        margin-right : 0.5%;
        
        width: 48%;
        
        margin-top : 5px;
    }
    
    .bouton_suppr
    {
        margin-left : 0.5%;
        margin-right : 1%;
        
        width: 48%;
        
        margin-top : 5px;
    }
    
</style>

<html>

    <head>
        <meta charset="utf-8" />
		
	<script type="text/javascript" src="../libsJS/jquery-3.1.1.min.js"></script>
	<link rel="icon" type="image/png" href="../img/favicon.png" />
                
        <title>VisualGraphs - Liste des annotations</title>
    </head>
	

    <!-- -->
    <h2>Liste des Annotations</h2>
    <p>Menu permettant d'afficher et de modifier les annotations.</p>

    <p>Le système d'annotation permet de prendre des notes sur les nœuds et les liens présent dans VisualGraphs, il est déconseillé de l'utiliser pour stoker des informations à long terme.</p>
    <br/>
    <p id="corps">Chargement des annotations en cours ...</p>

</html>


<script type="text/javascript">

    var xhr = new XMLHttpRequest();
        
    xhr.onload = function() 
    {
        if (xhr.readyState === 4) 
        {
            if (xhr.status === 200) 
            {
                var tabResult = JSON.parse(xhr.responseText);

                if (typeof tabResult.Erreur !== 'undefined')
                {
                    alert(tabResult.Erreur);
                }
                else
                    afficher(tabResult);
            }
        }
    };
    
    xhr.open("POST", 'RecupInfosAnnotations.php?localStorage=' + JSON.stringify(localStorage), true);
    
    xhr.send();

    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Permet d'afficher le contenu des tableaux à partir des éléments récupéré (Noeuds et Liens possédant des annotations) //
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    function afficher(tabResult)
    {
        var contenu = "";
        
        // Affichage des Noeuds
        contenu += '<h3>Annotations des Noeuds : </h3>';
        contenu += '<table>';
        contenu += '<tr><td class="titre_tableau"><b>Noeud</b></td><td class="titre_tableau"><b>Annotation</b></td></tr>';
        
        for(keyNoeud in tabResult["Noeuds"])
        {
            contenu += '<tr>';

                contenu += '<td>';

                    contenu += '<b>' + tabResult["Noeuds"][keyNoeud]["Type"] + '</b><br/>';

                    for(key in tabResult["Noeuds"][keyNoeud]["Values"])
                        contenu += key + ' : ' + tabResult["Noeuds"][keyNoeud]["Values"][key]+'<br/>';
                    
                    // Création d'un lien d'accès sur VisualGraphs
                    var lien = "../?requete='MATCH (el1) WHERE id(el1) = " + tabResult["Noeuds"][keyNoeud]['ID'] + " RETURN el1'&legende=Visualisation du noeuds de l'annotation&typeElSelect=Noeud&idElSelect="+tabResult["Noeuds"][keyNoeud]['ID'];
                    contenu += '<br/><a href="' + lien + '" target="_blank">Lien vers VisualGraphs</a>';

                contenu += '</td>';

                contenu += '<td>';
                    contenu += '<textarea id="textarea_n' + tabResult["Noeuds"][keyNoeud]['ID'] + '">' + tabResult["Noeuds"][keyNoeud]["Annotation"] + '</textarea>';
                    contenu += ' <button type="button" class="bouton_sav" id="sav_n' + tabResult["Noeuds"][keyNoeud]['ID'] + '">Sauvegarder</button> ';
                    contenu += ' <button type="button" class="bouton_suppr" id="suppr_n' + tabResult["Noeuds"][keyNoeud]['ID'] + '">Supprimmer</button> ';
                contenu += '</td>';

            contenu += '</tr>';
        }
        contenu +=  '</table>';

        // Affichage des Liens
        contenu += '<br/>';
        contenu += '<h3>Annotations des Liens : </h3>';
        contenu += '<table>';
        contenu += '<tr><td class="titre_tableau"><b>Lien</b></td><td class="titre_tableau"><b>Annotation</b></td></tr>';
        for(keyLien in tabResult["Liens"])
        {
            contenu += '<tr>';

                contenu += '<td>';

                    contenu += '<b>' + tabResult["Liens"][keyLien]["Type"] + '</b><br/>';

                    for(key in tabResult["Liens"][keyLien]["Values"])
                        contenu += key + ' : ' + tabResult["Liens"][keyLien]["Values"][key] + '<br/>';
                    
                    // Création d'un lien d'accès sur VisualGraphs
                    var lien = "../?requete='MATCH (el1)-[r]-(el2) WHERE id(r) = " + tabResult["Liens"][keyLien]['ID'] + " RETURN el1, el2, r'&legende=Visualisation du lien de l'annotation&typeElSelect=Lien&idElSelect="+tabResult["Liens"][keyLien]['ID'];
                    contenu += '<br/><a href="' + lien + '" target="_blank">Lien vers VisualGraphs</a>';

                contenu += '</td>';

                contenu += '<td>';
                    contenu += '<textarea id="textarea_l' + tabResult["Liens"][keyLien]['ID'] + '">' + tabResult["Liens"][keyLien]["Annotation"] + '</textarea>';
                    contenu += ' <button type="button" class="bouton_sav" id="sav_l' + tabResult["Liens"][keyLien]['ID'] + '">Sauvegarder</button> ';
                    contenu += ' <button type="button" class="bouton_suppr" id="suppr_l' + tabResult["Liens"][keyLien]['ID'] + '">Supprimmer</button> ';
                contenu += '</td>';

            contenu += '</tr>';
        }
        contenu += '</table>';
        
        // Mise à jour de l'affichage
        $("#corps").html(contenu);
        
        // Création des actions relatives aux boutons des noeuds
        for(keyNoeud in tabResult["Noeuds"])
        {
            GestionSavNoeuds(tabResult["Noeuds"][keyNoeud]['ID']);
            GestionSupprNoeuds(tabResult["Noeuds"][keyNoeud]['ID']);
        }
        
        // Création des actions relatives aux boutons des liens
        for(keyLien in tabResult["Liens"])
        {
            GestionSavLiens(tabResult["Liens"][keyLien]['ID']);
            GestionSupprLiens(tabResult["Liens"][keyLien]['ID']);
        }
    }
    
    /////////////////////////////////////////////////////////////////
    // Gestion de la sauvegarde de la nouvelle annotation du noeud //
    /////////////////////////////////////////////////////////////////
    function GestionSavNoeuds(id)
    {
        $("#sav_n"+id).click(function()
        {
            localStorage.setItem('Noeud_' + id, $("#textarea_n" + id).val());
            
            $("#textarea_n" + id).css("background-color", "#e2ffdf");
            setTimeout(function() {
                $("#textarea_n" + id).css("background-color", "#effaff");
            }, 250);
        });
    }
    
    //////////////////////////////////////////////////////////////////////////////////
    // Gestion de la suppression de l'annotation du noeud + rechargement de la page //
    //////////////////////////////////////////////////////////////////////////////////
    function GestionSupprNoeuds(id)
    {
        $("#suppr_n"+id).click(function()
        {
            localStorage.removeItem('Noeud_' + id);
            window.location.reload();
        });
    }
    
    ////////////////////////////////////////////////////////////////
    // Gestion de la sauvegarde de la nouvelle annotation du lien //
    ////////////////////////////////////////////////////////////////
    function GestionSavLiens(id)
    {
        $("#sav_l"+id).click(function()
        {
            localStorage.setItem('Lien_' + id, $("#textarea_l" + id).val());
            
            $("#textarea_l" + id).css("background-color", "#e2ffdf");
            setTimeout(function() {
                $("#textarea_l" + id).css("background-color", "#effaff");
            }, 250);
        });
    }
    
    /////////////////////////////////////////////////////////////////////////////////
    // Gestion de la suppression de l'annotation du lien + rechargement de la page //
    /////////////////////////////////////////////////////////////////////////////////
    function GestionSupprLiens(id)
    {
        $("#suppr_l"+id).click(function()
        {
            localStorage.removeItem('Lien_' + id);
            window.location.reload();
        });
    }

</script>






